| Example                                                          | Description                                                                                                  |
| ---------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------ |
| [`with-react`](./with-react)                                     | Shows a basic query in `urql` with React.                                                                    |
| [`with-react-native`](./with-react-native)                       | Shows a basic query in `urql` with React Native.                                                             |
| [`with-svelte`](./with-svelte)                                   | Shows a basic query in `@urql/svelte` with Svelte.                                                           |
| [`with-vue3`](./with-vue3)                                       | Shows a basic query in `@urql/vue` with Vue 3.                                                               |
| [`with-next`](./with-next)                                       | Shows some examples with `next-urql` in Next.js with the default, `getStaticProps` and `getServerSideProps`. |
| [`with-pagination`](./with-pagination)                           | Shows how to generically set up pagination with `urql` in UI code.                                           |
| [`with-infinite-pagination`](./with-infinite-pagination)         | Shows how to generically set up infinite scrolling pagination with `urql` in UI code.                        |
| [`with-apq`](./with-apq)                                         | Shows Automatic Persisted Queries with `@urql/exchange-persisted-fetch`.                                     |
| [`with-graphcache-updates`](./with-graphcache-updates)           | Shows manual cache updates with `@urql/exchange-graphcache`.                                                 |
| [`with-graphcache-pagination`](./with-graphcache-pagination)     | Shows the automatic infinite pagination helpers from `@urql/exchange-graphcache`.                            |
| [`with-multipart`](./with-multipart)                             | Shows file upload support with `@urql/exchange-multipart-fetch`.                                             |
| [`with-refresh-auth`](./with-refresh-auth)                       | Shows an example of authentication with refresh tokens using `@urql/exchange-auth`.                          |
| [`with-retry`](./with-retry)                                     | Shows how to set up `@urql/exchange-retry` for retrying failed operations.                                   |
| [`with-defer-stream-directives`](./with-defer-stream-directives) | Demonstrates `urql` and `@urql/exchange-graphcache` with built-in support for `@defer` and `@stream`.        |
| [`with-subscriptions-via-fetch`](./with-subscriptions-via-fetch) | Demonstrates `urql` executing subscriptions with a GraphQL Yoga API via the `fetchExchange`.                 |
